Index: dna-graph/src/main/java/org/jboss/dna/graph/sequencers/SequencerContext.java
===================================================================
--- dna-graph/src/main/java/org/jboss/dna/graph/sequencers/SequencerContext.java	(revision 702)
+++ dna-graph/src/main/java/org/jboss/dna/graph/sequencers/SequencerContext.java	(working copy)
@@ -21,8 +21,13 @@
  */
 package org.jboss.dna.graph.sequencers;
 
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
 import java.util.Set;
 import org.jboss.dna.common.collection.Problems;
+import org.jboss.dna.common.collection.SimpleProblems;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Name;
 import org.jboss.dna.graph.properties.Path;
@@ -31,21 +36,48 @@
 /**
  * @author John Verhaeg
  */
-public interface SequencerContext extends ExecutionContext {
+public class SequencerContext extends ExecutionContext {
 
+    private final Path inputPath;
+    private final Map<Name, Property> inputPropertiesByName;
+    private final Set<Property> inputProperties;
+    private final Problems problems;
+    private final String mimeType;
+
+    public SequencerContext( ExecutionContext context,
+                             Path inputPath,
+                             Set<Property> inputProperties,
+                             String mimeType,
+                             Problems problems ) {
+        super(context);
+        this.inputPath = inputPath;
+        this.inputProperties = inputProperties != null ? new HashSet<Property>(inputProperties) : new HashSet<Property>();
+        this.mimeType = mimeType;
+        this.problems = problems != null ? problems : new SimpleProblems();
+        Map<Name, Property> inputPropertiesByName = new HashMap<Name, Property>();
+        for (Property property : this.inputProperties) {
+            inputPropertiesByName.put(property.getName(), property);
+        }
+        this.inputPropertiesByName = Collections.unmodifiableMap(inputPropertiesByName);
+    }
+
     /**
      * Return the path of the input node containing the content being sequenced.
      * 
      * @return input node's path.
      */
-    Path getInputPath();
+    public Path getInputPath() {
+        return inputPath;
+    }
 
     /**
      * Return the set of properties from the input node containing the content being sequenced.
      * 
      * @return the input node's properties; never <code>null</code>.
      */
-    Set<Property> getInputProperties();
+    public Set<Property> getInputProperties() {
+        return inputProperties;
+    }
 
     /**
      * Return the property with the supplied name from the input node containing the content being sequenced.
@@ -53,14 +85,18 @@
      * @param name
      * @return the input node property, or <code>null</code> if none exists.
      */
-    Property getInputProperty( Name name );
+    public Property getInputProperty( Name name ) {
+        return inputPropertiesByName.get(name);
+    }
 
     /**
      * Return the MIME-type of the content being sequenced.
      * 
      * @return the MIME-type
      */
-    String getMimeType();
+    public String getMimeType() {
+        return this.mimeType;
+    }
 
     /**
      * Get an interface that can be used to record various problems, warnings, and errors that are not extreme enough to warrant
@@ -68,5 +104,7 @@
      * 
      * @return the interface for recording problems; never null
      */
-    Problems getProblems();
+    public Problems getProblems() {
+        return this.problems;
+    }
 }
Index: dna-common/src/test/java/org/jboss/dna/common/jcr/AbstractJcrRepositoryTest.java
===================================================================
--- dna-common/src/test/java/org/jboss/dna/common/jcr/AbstractJcrRepositoryTest.java	(revision 702)
+++ dna-common/src/test/java/org/jboss/dna/common/jcr/AbstractJcrRepositoryTest.java	(working copy)
@@ -42,8 +42,8 @@
  * Typically, unit test classes need a repository for just some of it's unit tests (other unit tests don't need the repository
  * because they are just testing other functionality of the class under test), and this class was designed for this scenario. A
  * unit test method that needs a repository should call {@link #startRepository()}, and then may proceed to use the
- * {@link #getRepository() repository}. The test method need not call {@link #shutdownRepository()}, as it is called
- * automatically after every test (and does nothing if the repository was not started in the first place).
+ * {@link #getRepository() repository}. The test method need not call {@link #shutdownRepository()}, as it is called automatically
+ * after every test (and does nothing if the repository was not started in the first place).
  * </p>
  * <p>
  * Some unit test methods may have a need to repeatedly start and stop the repository, and this can be done by calling
@@ -172,4 +172,5 @@
     public Credentials getTestCredentials() {
         return this.simpleCredentials;
     }
+
 }
Index: docs/examples/gettingstarted/repositories/src/main/java/org/jboss/example/dna/repository/RepositoryClient.java
===================================================================
--- docs/examples/gettingstarted/repositories/src/main/java/org/jboss/example/dna/repository/RepositoryClient.java	(revision 702)
+++ docs/examples/gettingstarted/repositories/src/main/java/org/jboss/example/dna/repository/RepositoryClient.java	(working copy)
@@ -42,7 +42,6 @@
 import org.jboss.dna.common.text.NoOpEncoder;
 import org.jboss.dna.common.util.CheckArg;
 import org.jboss.dna.connector.inmemory.InMemoryRepositorySource;
-import org.jboss.dna.graph.BasicExecutionContextFactory;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
 import org.jboss.dna.graph.Graph;
@@ -130,7 +129,7 @@
         if (repositoryService != null) return; // already started
 
         // Create the factory for execution contexts.
-        contextFactory = new BasicExecutionContextFactory();
+        contextFactory = new ExecutionContext();
 
         // Create the execution context that we'll use for the services. If we'd want to use JAAS, we'd create the context
         // by supplying LoginContext, AccessControlContext, or even Subject with CallbackHandlers. But no JAAS in this example.
Index: docs/examples/gettingstarted/sequencers/src/main/java/org/jboss/example/dna/sequencers/SequencingClient.java
===================================================================
--- docs/examples/gettingstarted/sequencers/src/main/java/org/jboss/example/dna/sequencers/SequencingClient.java	(revision 702)
+++ docs/examples/gettingstarted/sequencers/src/main/java/org/jboss/example/dna/sequencers/SequencingClient.java	(working copy)
@@ -49,7 +49,6 @@
 import org.jboss.dna.repository.observation.ObservationService;
 import org.jboss.dna.repository.sequencers.SequencerConfig;
 import org.jboss.dna.repository.sequencers.SequencingService;
-import org.jboss.dna.repository.util.BasicJcrExecutionContext;
 import org.jboss.dna.repository.util.JcrExecutionContext;
 import org.jboss.dna.repository.util.JcrTools;
 import org.jboss.dna.repository.util.SessionFactory;
@@ -210,8 +209,7 @@
 
             // Create an execution context for the sequencing service. This execution context provides an environment
             // for the DNA services which knows about the JCR repositories, workspaces, and credentials used to
-            // establish sessions to these workspaces. This example uses the BasicJcrExecutionContext, but there is
-            // implementation for use with JCR repositories registered in JNDI.
+            // establish sessions to these workspaces.
             final String repositoryWorkspaceName = this.repositoryName + "/" + this.workspaceName;
             SimpleSessionFactory sessionFactory = new SimpleSessionFactory();
             sessionFactory.registerRepository(this.repositoryName, this.repository);
@@ -219,7 +217,7 @@
                 Credentials credentials = new SimpleCredentials(this.username, this.password);
                 sessionFactory.registerCredentials(repositoryWorkspaceName, credentials);
             }
-            this.executionContext = new BasicJcrExecutionContext(sessionFactory, repositoryWorkspaceName);
+            this.executionContext = new JcrExecutionContext(sessionFactory, repositoryWorkspaceName);
 
             // Create the sequencing service, passing in the execution context ...
             this.sequencingService = new SequencingService();
Index: docs/reference/src/main/docbook/en-US/custom.dtd
===================================================================
--- docs/reference/src/main/docbook/en-US/custom.dtd	(revision 702)
+++ docs/reference/src/main/docbook/en-US/custom.dtd	(working copy)
@@ -60,10 +60,8 @@
 <!ENTITY Node								       		"<ulink url='&API;graph/Node.html'><interface>Node</interface></ulink>">
 <!ENTITY Results							       	"<ulink url='&API;graph/Results.html'><interface>Results</interface></ulink>">
 <!ENTITY Location							       	"<ulink url='&API;graph/Location.html'><classname>Location</classname></ulink>">
-<!ENTITY ExecutionContext		       		"<ulink url='&API;graph/ExecutionContext.html'><interface>ExecutionContext</interface></ulink>">
+<!ENTITY ExecutionContext		       		"<ulink url='&API;graph/ExecutionContext.html'><classname>ExecutionContext</classname></ulink>">
 <!ENTITY ExecutionContextFactory   		"<ulink url='&API;graph/ExecutionContextFactory.html'><interface>ExecutionContextFactory</interface></ulink>">
-<!ENTITY BasicExecutionContext		    "<ulink url='&API;graph/BasicExecutionContext.html'><classname>BasicExecutionContext</classname></ulink>">
-<!ENTITY BasicExecutionContextFactory "<ulink url='&API;graph/BasicExecutionContextFactory.html'><classname>BasicExecutionContextFactory</classname></ulink>">
 <!ENTITY Name								       		"<ulink url='&API;graph/properties/Name.html'><interface>Name</interface></ulink>">
 <!ENTITY Path								       		"<ulink url='&API;graph/properties/Path.html'><interface>Path</interface></ulink>">
 <!ENTITY PathSegment				       		"<ulink url='&API;graph/properties/Path.Segment.html'><interface>Path.Segment</interface></ulink>">
@@ -101,7 +99,6 @@
 <!ENTITY JndiSessionFactory				 		"<ulink url='&API;repository/util/JndiSessionFactory.html'><classname>JndiSessionFactory</classname></ulink>">
 <!ENTITY SimpleSessionFactory				 	"<ulink url='&API;repository/util/SimpleSessionFactory.html'><classname>SimpleSessionFactory</classname></ulink>">
 <!ENTITY JcrExecutionContext	   			"<ulink url='&API;repository/util/JcrExecutionContext.html'><interface>JcrExecutionContext</interface></ulink>">
-<!ENTITY BasicJcrExecutionContext	  	"<ulink url='&API;repository/util/BasicJcrExecutionContext.html'><classname>BasicJcrExecutionContext</classname></ulink>">
 <!ENTITY MimeType									  	"<ulink url='&API;repository/mimetype/MimeType.html'><classname>MimeType</classname></ulink>">
 <!ENTITY MimeTypeDetectorConfig		  	"<ulink url='&API;repository/mimetype/MimeTypeDetectorConfig.html'><interface>MimeTypeDetectorConfig</interface></ulink>">
 
Index: dna-jcr/src/test/java/org/jboss/dna/jcr/TestUtil.java
===================================================================
--- dna-jcr/src/test/java/org/jboss/dna/jcr/TestUtil.java	(revision 702)
+++ dna-jcr/src/test/java/org/jboss/dna/jcr/TestUtil.java	(working copy)
@@ -26,7 +26,6 @@
 import javax.security.auth.callback.CallbackHandler;
 import javax.security.auth.login.LoginContext;
 import net.jcip.annotations.NotThreadSafe;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
 import org.jboss.dna.graph.connectors.RepositoryConnection;
@@ -503,7 +502,7 @@
     }
 
     public static ExecutionContextFactory getExecutionContextFactory() {
-        final ExecutionContext context = new BasicExecutionContext(Mockito.mock(LoginContext.class));
+        final ExecutionContext context = new ExecutionContext().create(Mockito.mock(LoginContext.class));
         NamespaceRegistry registry = context.getNamespaceRegistry();
         registry.register("dna", "http://www.jboss.org/dna/1.0");
         registry.register("fn", "http://www.w3.org/2005/xpath-functions");
Index: dna-jcr/src/test/java/org/jboss/dna/jcr/JcrPropertyTest.java
===================================================================
--- dna-jcr/src/test/java/org/jboss/dna/jcr/JcrPropertyTest.java	(revision 702)
+++ dna-jcr/src/test/java/org/jboss/dna/jcr/JcrPropertyTest.java	(working copy)
@@ -34,7 +34,6 @@
 import javax.jcr.Value;
 import javax.jcr.ValueFormatException;
 import javax.jcr.nodetype.PropertyDefinition;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Name;
 import org.jboss.dna.graph.properties.Path;
@@ -52,7 +51,7 @@
     private Property prop;
     @Mock
     private Node node;
-    private ExecutionContext executionContext = new BasicExecutionContext();
+    private ExecutionContext executionContext = new ExecutionContext();
     @Mock
     Name name;
 
Index: dna-jcr/src/test/java/org/jboss/dna/jcr/JcrMultiValuePropertyTest.java
===================================================================
--- dna-jcr/src/test/java/org/jboss/dna/jcr/JcrMultiValuePropertyTest.java	(revision 702)
+++ dna-jcr/src/test/java/org/jboss/dna/jcr/JcrMultiValuePropertyTest.java	(working copy)
@@ -35,7 +35,6 @@
 import javax.jcr.Value;
 import javax.jcr.ValueFormatException;
 import javax.jcr.nodetype.PropertyDefinition;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Name;
 import org.jboss.dna.graph.properties.Path;
@@ -53,7 +52,7 @@
     private Property prop;
     @Mock
     private Node node;
-    private ExecutionContext executionContext = new BasicExecutionContext();
+    private ExecutionContext executionContext = new ExecutionContext();
     @Mock
     Name name;
 
